=== python/Makefile ===
# Copyright (c) 2005-2017 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
#
#
#

all: release test

clean:
	python setup.py clean
	-rm -rf build/ tbb_wrap.* _TBB.* *.pyc TBB.py*

release: TBB.py

TBB.py: tbb.i tbb.src.py setup.py
	python setup.py build_ext -f --inplace

test: TBB.py
	python TBB.py test

install:
	python setup.py install

test-install:
	@echo Testing installed module
	python -m TBB test
