=== debian/changelog ===
tbb (2017~U7-8) unstable; urgency=medium

  * Remove un-aligned memory access unit test from test_malloc_pools.exe
    - This allows sparc64 to pass unit tests. Closes: #832104

  [ Adrian Bunk ]
  * Advertise exception_ptr with gcc >= 7, Closes: #877380

 -- Steve Capper <steven.capper@gmail.com>  Wed, 04 Oct 2017 14:46:23 +0100

tbb (2017~U7-7~exp1) experimental; urgency=medium

  * Remove un-aligned memory access unit test from test_malloc_pools.exe
    - This should help sparc64

 -- Steve Capper <steven.capper@gmail.com>  Mon, 14 Aug 2017 17:41:33 +0100

tbb (2017~U7-6) unstable; urgency=medium

  * Rollback enhanced debugging -g3 change, as it appears to have broken
    reproducible builds.

 -- Steve Capper <steven.capper@gmail.com>  Wed, 02 Aug 2017 19:03:30 +0100

tbb (2017~U7-5) unstable; urgency=medium

  * Release to sid
  * Enhanced debugging, gdb analysis for failed tbbmalloc tests
  * Display host system page size

 -- Steve Capper <steven.capper@gmail.com>  Tue, 01 Aug 2017 21:20:40 +0100

tbb (2017~U7-5~exp1) experimental; urgency=medium

  * Enhanced debugging, gdb analysis for failed tbbmalloc tests
  * Display host system page size

 -- Steve Capper <steven.capper@gmail.com>  Sun, 30 Jul 2017 21:42:32 +0100

tbb (2017~U7-4) unstable; urgency=medium

  * Remove spurious patch files
  * Fix build on ARMEL. Closes: #852481
  * Remove build information to help reproducible builds. Closes: #816989
  * Fixup 64-bits detection patch
  * Use 1MB stack for 32-bit MIPS test threads
  * Merge failonbadtests and tally-unit-test-fails.patch
  * Fix -march logic in i386 building. Closes: #855088
    + (we use gcc atomics by default so no longer need to mention pentium4)
  * Bump standards to 4.0.0

  [ Matthias Klose ]
  * Fix multi-arch support, Closes: #812945

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass build configuration to make. Closes: #837179

 -- Steve Capper <steven.capper@gmail.com>  Thu, 27 Jul 2017 20:52:44 +0100

tbb (2017~U7-3~exp1) experimental; urgency=medium

  [ Matthias Klose ]
  * Fix multi-arch support, Targets: #812945

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass build configuration to make. Targets: #837179

  [ Steve Capper ]
  * Remove spurious patch files
  * Fix build on ARMEL. Targets: #852481
  * Attempt to debug pthread_create failures on mips
  * Remove build information to help reproducible builds. Targets: #816989

 -- Steve Capper <steven.capper@gmail.com>  Sun, 23 Jul 2017 19:08:41 +0100

tbb (2017~U7-2) unstable; urgency=medium

  * Port over experimental package to sid.
  * Upgrade to latest upstream version of TBB.
    + This now builds with gcc 7. Closes: #853679
    + This supports s390x. Closes: #809663
  * Update copyright file to Apache 2.0 to match new upstream version.
  * Fix -march logic in i386 building. Targets: #855088
  * Fix watch file to point to new upstream on github. Closes: #866678

  [ Nico Schlömer ]
  * Correct homepage and add Vcs tags in debian/control.

 -- Steve Capper <steven.capper@gmail.com>  Sun, 23 Jul 2017 12:55:42 +0100

tbb (2017~U7-1~exp1) experimental; urgency=medium

  * Upgrade to latest upstream version of TBB.
    + This now builds with gcc 7. Targets: #853679
    + This supports s390x. Targets: #809663
  * Update copyright file to Apache 2.0 to match new upstream version.
  * Fix -march logic in i386 building. Targets: #855088
  * Fix watch file to point to new upstream on github. Targets: #866678

 -- Steve Capper <steven.capper@gmail.com>  Sat, 08 Jul 2017 10:45:31 +0100
