=== debian/watch ===
version=4
opts="compression=xz,repack,uversionmangle=s/\./~U/,filenamemangle=s%.*/(\d{4})_U(\d+)\.tar\.gz%@PACKAGE@_$1~U$2.tar.gz%" \
             https://github.com/01org/@PACKAGE@/tags \
             .*/(\d{4})_U(\d+)\.tar\.gz debian uupdate
