=== debian/rules ===
--- 
+++ 
@@ -55,6 +55,7 @@
 	cat /proc/cpuinfo
 	gcc -dM -E - < /dev/null
 	echo Build system page size is $$(($$(getconf PAGESIZE) >> 10)) KiB
+	make default
 
 	sed -e"s/@VERSION@/$(VERSION)/g;s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
 		debian/tbb.pc.in > debian/tbb.pc
